#ifndef _ACTIVITY_LEDS_H_
#define _ACTIVITY_LEDS_H_

/*
   *
   * activity_leds.h
   *
   * Copyright (c) 2002-2003 Aleksander Augustowski
   *
   * BUG RAPORTS &
   * E-MAIL:          aleksander.augustowski@ins.com.pl
   * URL:             http://www.ins.com.pl/~alex/bcount/bcount.html
   *
   * This software is open source; you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation; either version 2 of the License, or
   * (at your option) any later version.
   *
   * This program is distributed WITHOUT ANY WARRANTY; without even the
   * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   * See the GNU General Public License in the included COPYING file for
   * details.
   *
   *
*/


#define TX_LED		"TX"
#define RX_LED		"RX"


char *tx_led = TX_LED;
char *rx_led = RX_LED;


void turn_led_on(char *which)
{
	if (which == tx_led)
	    {
		wattron (now_window, COLOR_PAIR(6));
		wattron (now_window, A_UNDERLINE);
		mvwaddstr (now_window, 11, 13, "TX");
	    }
	else if (which == rx_led)
	    {
		wattron (now_window, COLOR_PAIR(10));
		wattron (now_window, A_UNDERLINE);
		mvwaddstr (now_window, 11, 30, "RX");
	    }

	wattron (now_window, COLOR_PAIR(1));

	wrefresh (now_window);
}


void turn_led_off(char *which)
{
	if (which == tx_led)
	    {
		wattron (now_window, COLOR_PAIR(11));
		wattroff (now_window, A_UNDERLINE);
		mvwaddstr (now_window, 11, 13, "TX");
	    }
	else if (which == rx_led)
	    {
		wattron (now_window, COLOR_PAIR(12));
		wattroff (now_window, A_UNDERLINE);
		mvwaddstr (now_window, 11, 30, "RX");
	    }
	    
	wattron (now_window, COLOR_PAIR(1));

	wrefresh (now_window);
}


/* Deactivate fu***n leds */
void deactivate_leds(void)
{
	turn_led_off(TX_LED);
	turn_led_off(RX_LED);
}


/* Your eyes will bleeding if you see fu***n leds */
void activate_leds(void)
{
	if (activity_leds_flag == TRUE)
	    {
	        /* If we get new packets and 
		    activity_leds_flag == TRUE then blink tx led */
		if (i->stats.tx_packets != i->stats.tx_packets_last)
		    turn_led_on(TX_LED);
		else
		    turn_led_off(TX_LED);
		/* If we get new packets and 
		    activity_leds_flag == TRUE then blink rx led */
		if (i->stats.rx_packets != i->stats.rx_packets_last)
		    turn_led_on(RX_LED);
		else
		    turn_led_off(RX_LED);
	    }
	/* If activity_leds_flag == FALSE then do't blink 
	    any fu***n leds */
	else if (activity_leds_flag == FALSE)
	    {
		turn_led_off(TX_LED);
		turn_led_off(RX_LED);
	    }

	/* This is important */
	wattron (now_window, COLOR_PAIR(1));
	wattron (now_window, A_UNDERLINE);

	wrefresh (now_window);
}		    


/* NIN */

#endif /* _ACTIVITY_LEDS_H_ */


