#ifndef _HOST_NAME_H_
#define _HOST_NAME_H_

/*
   *
   * host_name.h
   *
   * Copyright (c) 2002-2003 Aleksander Augustowski
   *
   * BUG RAPORTS &
   * E-MAIL:          aleksander.augustowski@ins.com.pl
   * URL:             http://www.ins.com.pl/~alex/bcount/bcount.html
   *
   * This software is open source; you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation; either version 2 of the License, or
   * (at your option) any later version.
   *
   * This program is distributed WITHOUT ANY WARRANTY; without even the
   * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   * See the GNU General Public License in the included COPYING file for
   * details.
   *
   *
*/


#include <netdb.h>


char local_host_name[100];

struct hostent *local_hostent;


/* Get host node and domain name */
char* get_local_host_name(void)
{
	local_hostent = gethostbyname (get_local_host_info(HOST_SHORT_NAME));

	free(u_name);

	if (local_hostent == NULL)
	    {
		fprintf (stderr, _STRING_RED_": Can't get local host name"
			",\nuse `localhost'.\n", strerror(h_errno));
		syslog (LOG_ERR, "-ERR: Can't get local host name"
			", use `localhost'.");

		closelog();

		return "localhost";
	    }

	return local_hostent->h_name;
}	    



/* NIN */

#endif /* _HOST_NAME_H_ */

