#ifndef _SIGNALS_H_
#define _SIGNALS_H_

/*
   *
   * signals.h
   *
   * Copyright (c) 2002-2003 Aleksander Augustowski
   *
   * BUG RAPORTS &
   * E-MAIL:          aleksander.augustowski@ins.com.pl
   * URL:             http://www.ins.com.pl/~alex/bcount/bcount.html
   *
   * This software is open source; you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation; either version 2 of the License, or
   * (at your option) any later version.
   *
   * This program is distributed WITHOUT ANY WARRANTY; without even the
   * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   * See the GNU General Public License in the included COPYING file for
   * details.
   *
   *
*/


#include <signal.h>
#include "signalnum.h"


static void sigcore(int signal_number) __attribute__ ((noreturn));


void signals_information(void)
{
	printf (_COLOR_WHITE_"Signame      Signum        Information                        Standrad"_COLOR_END_"\n"       
		"SIGHUP         1	    Hangup				POSIX\n"                
		"SIGINT         2	    Interrupt (ex. Ctrl + C)		ANSI\n"
		"SIGQUIT        3	    Quit (ex. Ctrl + \\)                 POSIX\n" 
		"SIGILL         4	    Illegal instruction			ANSI\n"
		"SIGTRAP        5	    Trace trap 				POSIX\n" 
		"SIGABRT        6	    Abort (ex. abort() fuction)		ANSI\n"
		"SIGIOT         6	    IOT trap 				4.2 BSD\n" 
		"SIGBUS         7	    BUS error 				4.2 BSD\n" 
		"SIGFPE         8	    Floating-point exception 		ANSI\n"
		"SIGKILL        9	    Kill, unblockable			POSIX\n"
		"SIGUSR1        10	    User-defined signal 1		POSIX\n"
		"SIGSEGV        11	    Segmentation violation		ANSI\n"
		"SIGUSR2        12	    User-defined signal 2		POSIX\n"
		"SIGPIPE        13	    Broken pipe				POSIX\n"
		"SIGALRM        14	    Alarm clock				POSIX\n"
		"SIGTERM        15	    Termination				ANSI\n"
		"SIGSTKFLT      16	    Stack fault\n"
		"SIGCLD         SIGCHLD	    Same as SIGCHLD			System V\n" 
		"SIGCHLD        17	    Child status has changed		POSIX\n"
		"SIGCONT        18	    Continue				POSIX\n"
		"SIGSTOP        19	    Stop, unblockable			POSIX\n"
		"SIGTSTP        20	    Keyboard stop (ex. Ctrl + Z) 	POSIX\n"
		"SIGTTIN        21	    Background read from tty		POSIX\n"
		"SIGTTOU        22	    Background write to tty		POSIX\n"
		"SIGURG         23	    Urgent condition on socket		4.2 BSD\n"
		"SIGXCPU        24	    CPU limit exceeded			4.2 BSD\n"
		"SIGXFSZ        25	    File size limit exceeded		4.2 BSD\n"
		"SIGVTALRM      26	    Virtual alarm clock			4.2 BSD\n"
		"SIGPROF        27	    Profiling alarm clock		4.2 BSD\n"
		"SIGWINCH       28	    Window size change			4.3 BSD, Sun\n"
		"SIGPOLL        SIGIO	    Pollable event occurred		System V\n"
		"SIGIO          29	    I/O now possible			4.2 BSD\n"
		"SIGPWR         30	    Power failure restart		System V\n"
		"SIGSYS         31	    Bad system call\n"
		"SIGUNUSED      31\n");

	exit_prog(EXIT_SUCCESS);
}


char* signal_itoa(int signal_number)
{
	if (signal_number == SIGHUP)
	    return ASIGHUP;
	else if (signal_number == SIGINT)
	    return ASIGINT;
	else if (signal_number == SIGQUIT)
	    return ASIGQUIT;
	else if (signal_number == SIGILL)
	    return ASIGILL;
	else if (signal_number == SIGTRAP)
	    return ASIGTRAP;
	else if (signal_number == SIGABRT)
	    return ASIGABRT;
	else if (signal_number == SIGIOT)
	    return ASIGIOT;
	else if (signal_number == SIGBUS)
	    return ASIGBUS;
	else if (signal_number == SIGFPE)
	    return ASIGFPE;
	else if (signal_number == SIGKILL)
	    return ASIGKILL;
	else if (signal_number == SIGUSR1)
	    return ASIGUSR1;
	else if (signal_number == SIGSEGV)
	    return ASIGSEGV;
	else if (signal_number == SIGUSR2)
	    return ASIGUSR2;
	else if (signal_number == SIGPIPE)
	    return ASIGPIPE;
	else if (signal_number == SIGALRM)
	    return ASIGALRM;
	else if (signal_number == SIGTERM)
	    return ASIGTERM;
	else if (signal_number == SIGSTKFLT)
	    return ASIGSTKFLT;
	else if (signal_number == SIGCLD)
	    return ASIGCHLD;
	else if (signal_number == SIGCHLD)
	    return ASIGCHLD;
	else if (signal_number == SIGCONT)
	    return ASIGCONT;
	else if (signal_number == SIGSTOP)
	    return ASIGSTOP;
	else if (signal_number == SIGTSTP)
	    return ASIGTSTP;
	else if (signal_number == SIGTTIN)
	    return ASIGTTIN;
	else if (signal_number == SIGTTOU)
	    return ASIGTTOU;
	else if (signal_number == SIGURG)
	    return ASIGURG;
	else if (signal_number == SIGXCPU)
	    return ASIGXCPU;
	else if (signal_number == SIGXFSZ)
	    return ASIGXFSZ;
	else if (signal_number == SIGVTALRM)
	    return ASIGVTALRM;
	else if (signal_number == SIGPROF)
	    return ASIGPROF;
	else if (signal_number == SIGWINCH)
	    return ASIGWINCH;
	else if (signal_number == SIGPOLL)
	    return ASIGPOLL;
	else if (signal_number == SIGIO)
	    return ASIGIO;
	else if (signal_number == SIGPWR)
	    return ASIGPWR;
	else if (signal_number == SIGSYS)
	    return ASIGSYS;

	return ASIGUNKNOWN;
}


void write_to_author_msg(void)
{
	fprintf (stderr, "Please write about this to: \033[1;37m%s\033[0m\n", 
		email_address);
}


#ifdef _BCOUNT_H_
void normal_termination_msg(int signal_number)
{
        fprintf (stderr ,"\n\033[1;30m>\033[0m>\033[1;37m>\033[0m "
		"Program Termination \033[1;37m<\033[0m<\033[1;30m<\033[0m\n");

	fprintf (stderr, "Program %s received %s Signal: exiting(1) ...\n\n"
			"Last called function: "_STRING_RED_"\n\n", exec_name, 
			signal_itoa(signal_number), running_function);
}
#endif /* #ifdef _BCOUNT_H_ */


void abnormal_termination_msg(int signal_number)
{
	fprintf (stderr, "\n\033[1;30m>\033[0m>\033[1;37m>\033[0m Abnormal "
		"program termination \033[1;37m<\033[0m<\033[1;30m<\033[0m\n");

	fprintf (stderr, "Program %s received %s Signal: exiting(1) ...\n\n"
			"Last called function: "_STRING_RED_"\n\n", exec_name, 
			signal_itoa(signal_number), running_function);
}


#ifdef _BSERVER_H_
/* Ignore PIPE signal. Close connection with client */
static void sigpipe()
{
	quantity_signals++;

	close(client_socket);
}


/* Ctrl+C, Ctrl+\ in server mode */
static void sigterm_server(int signal_number)
{
	quantity_signals++;

	pthreads_shutting_down(ALL_THREADS);	

	fprintf (stdout, "\n%lu connections\n", how_many_connections);
	fprintf (stdout, "Close connection with client.\nExit.\n");

	close(client_socket);
	closelog();
	
	exit_prog(EXIT_FALSE);
}
#endif /* #ifdef _BSERVER_H_ */


/* "Abnormal" signals. Core dumped termination */
static void sigcore(int signal_number)
{
	error_function = (char*) xmalloc (sizeof(running_function));

	quantity_signals++;

	strcpy (error_function, running_function);

#ifdef _BCOUNT_H_
	if (curses_flag == TRUE)
	    {
		//syncing_and_down_threads();
		close_ncurses_screen();
	    }
#elif
	pthreads_shutting_down(ALL_THREADS);
#endif

	abnormal_termination_msg(signal_number);

	fprintf(stderr, "Trying automaticaly send BUG REPORT to author "
			"by e-mail, please wait ...");

	if (smtp_init_flag == FALSE)
	    {
		printf(_STRING_RED_"\n", STRING_FAIL);
		write_to_author_msg();		
	    }
	else
	    {
		strcpy(get_mail_address, email_address);
		
		check_exit = (connect_to_smtp_server("core"));

		if (check_exit == EXIT_SUCCESS)
		    printf(_STRING_WHITE_"\n", STRING_OK);
		else if (check_exit == EXIT_QUEUED)
		    printf(_STRING_WHITE_" (queued)\n", STRING_OK);
		else if (check_exit == EXIT_FALSE)
		    {
			printf(_STRING_RED_"\n", STRING_FAIL);
			write_to_author_msg();		
		    }

		fflush(stdout);
		fflush(stderr);
	    }
	
	syslog (LOG_ERR, ">>> Abnormal program termination <<< signal number "
		"= %d [%s]", signal_number, signal_itoa(signal_number));
	syslog (LOG_ERR, "    Errno: %d -> %s", errno, strerror(errno));
	closelog();

	free(error_function);

	exit_prog(EXIT_FALSE);
}


#ifdef _BCOUNT_H_
/* "Normal" signals. Break running process */
static void sigterm(int signal_number)
{
	quantity_signals++;
	
	if (curses_flag == TRUE)
	    {
		syncing_and_down_threads();

		close_ncurses_screen();
		clrscr();
		print_version();
		copyright_info(1);
		print_process_stats();
		fprintf (stdout, _COLOR_WHITE_"Termination with signal number "
			"= %d [%s]"_COLOR_END_"\n", signal_number,
			signal_itoa(signal_number));
		fprintf (stdout, "Please run `"_COLOR_WHITE_"%s --signals"
			_COLOR_END_"' to see information about "
			"signal\n\n", exec_name);
	
		fflush(stdout);
		
		pthreads_shutting_down(ALL_THREADS);
		
		exit_prog(EXIT_FALSE);
	    }
	else
	    {
		normal_termination_msg(signal_number);

		exit_prog(EXIT_FALSE);
	    }

}


/* Ignore SIGPIPE signal. Close SMTP connection */
static void sigpipe()
{
	quantity_signals++;

	close(smtp_socket);
}
#endif /* #ifdef _BCOUNT_H_ */


static void signals_functions(void)
{
	/* Maintenance of signals */
#ifdef _BSERVER_H_
	signal(SIGQUIT, sigterm_server);
	signal(SIGINT, sigterm_server);
	signal(SIGABRT, sigterm_server);
	signal(SIGIOT, sigterm_server);
	signal(SIGURG, sigterm_server);
	signal(SIGVTALRM, sigterm_server);
	signal(SIGPROF, sigterm_server);
	signal(SIGPOLL, sigterm_server);
	signal(SIGIO, sigterm_server);
#endif
#ifdef _BCOUNT_H_
	signal(SIGQUIT, sigterm);
	signal(SIGINT, sigterm);
	signal(SIGABRT, sigterm);
	signal(SIGIOT, sigterm);
	signal(SIGURG, sigterm);
	signal(SIGVTALRM, sigterm);
	signal(SIGPROF, sigterm);
	signal(SIGPOLL, sigterm);
	signal(SIGIO, sigterm);
#endif
	signal(SIGTERM, SIG_IGN);
	signal(SIGTRAP, SIG_IGN);
	signal(SIGHUP, SIG_IGN);
	signal(SIGILL, sigcore);
	signal(SIGBUS, sigcore);
	signal(SIGFPE, sigcore);
	/* signal(SIGKILL, sigcore); */ /* Unblokable :-( */
	signal(SIGUSR1, SIG_IGN);
	signal(SIGSEGV, sigcore);
	signal(SIGUSR2, SIG_IGN);
	signal(SIGPIPE, sigpipe);
	signal(SIGALRM, SIG_IGN);
	signal(SIGSTKFLT, sigcore);
	signal(SIGCHLD, SIG_IGN);
	signal(SIGCONT, SIG_IGN);
	/* signal(SIGSTOP, sigcore); */ /* Unblokable :-( */
	signal(SIGTSTP, SIG_IGN);
	signal(SIGTTIN, SIG_IGN);
	signal(SIGTTOU, SIG_IGN);
	signal(SIGXCPU, sigcore);
	signal(SIGXFSZ, sigcore);
	signal(SIGWINCH, SIG_IGN);
	signal(SIGPWR, SIG_IGN);
	signal(SIGSYS, sigcore);
}


/* NIN */

#endif /* _SIGNALS_H_ */

