#ifndef _WINDOWS_UTILS_H_
#define _WINDOWS_UTILS_H_

/*
   *
   * windows_utils.h
   *
   * Copyright (c) 2002-2003 Aleksander Augustowski
   *
   * BUG RAPORTS &
   * E-MAIL:          aleksander.augustowski@ins.com.pl
   * URL:             http://www.ins.com.pl/~alex/bcount/bcount.html
   *
   * This software is open source; you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation; either version 2 of the License.
   *
   * This program is distributed WITHOUT ANY WARRANTY; without even the
   * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   * See the GNU General Public License in the included COPYING file for
   * details.
   *
   *
*/


#define BOTTOM		"bottom"
#define TOP		"top"



/* Fill Window (char 32 -> space) */
void fill_window (WINDOW *win)
{
	int x = 1, y = 1, i = 0, z = 0;
	int *x_max = xmalloc (sizeof(int));
	int *y_max = xmalloc (sizeof(int));
	
	getmaxyx (win, *x_max, *y_max);

	for (z = y; z < *y_max - 1; z++)
	    {
		move (x, y);
		for (i = x; i < *x_max - 1; i++)
		    mvwprintw (win, i, y, " ");
		y++;
	    }
	
	free(x_max);
	free(y_max);
}


/* Fill Window (char 32 -> space) */
void fill_panel (WINDOW *win)
{
	int x = 0;
	int *x_max = xmalloc (sizeof(int));
	int *y_max = xmalloc (sizeof(int));
	
	getmaxyx (win, *y_max, *x_max);

	free(y_max);

	for (x = 0; x < *x_max; x++)
	    mvwprintw (win, 0, x, " ");

	free(x_max);
}


/* Get string lenght and put in the middle of Window */
void text_window_in_middle (WINDOW *win, char *label_window, char *place)
{
	int *y = xmalloc (sizeof(int));
	int *x_max = xmalloc (sizeof(int));
	int *y_max = xmalloc (sizeof(int));

	getmaxyx (win, *y_max, *x_max);

	if (place == BOTTOM)
	    *y = *y_max - 1;

	if (place == TOP)
	    *y = 0;

	mvwprintw (win, *y, ((*x_max / 2) - ((strlen (label_window)) / 2)), 
		    "%s", label_window);

	free(y);
	free(x_max);
	free(y_max);
}



/* NIN */

#endif /* _WINDOWS_UTILS_H_ */

